import java.io.*; 

public class SerializedCircle implements Serializable {
	public int radius = 0;

	public SerializedCircle circleRef = null;

	public SerializedCircle(int radius) {
		this.radius = radius;
	}
	
	public static void writeObject(String fileName, SerializedCircle circle) {
		try {
			ObjectOutputStream objectOut = 
				new ObjectOutputStream(
					new BufferedOutputStream(
						new FileOutputStream(fileName) ) );
			objectOut.writeObject(circle);

			objectOut.close();
		} catch (Exception e) {
			e.printStackTrace(System.err);
			System.exit(1);
		}
	}

	public static SerializedCircle readObject(String fileName) {
		SerializedCircle circle = null;
		try {
			ObjectInputStream objectIn = 
				new ObjectInputStream(
					new BufferedInputStream(
						new FileInputStream(fileName) ) );
			circle = (SerializedCircle)(objectIn.readObject());

			objectIn.close();
		} catch (Exception e) {
			e.printStackTrace(System.err);
			System.exit(1);
		}
		return circle;
	}

	/** Main method */
	public static void main(String[] args) {
		SerializedCircle circle = new SerializedCircle(5);
		circle.circleRef = circle;
		writeObject("objects.srz", circle);

		SerializedCircle circleCopy = readObject("objects.srz");
		System.out.println("circleCopy.radius : " + circleCopy.radius); 
		System.out.println("circleRef == this : " + (circleCopy.circleRef == circleCopy)); 
	}
}